diff --git a/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java b/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
index f66625e1f..e8c4dd3ed 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
@@ -3,20 +3,23 @@ package net.minecraft.client.gui.guidebook.trommeling;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiRenderItem;
 import net.minecraft.client.gui.GuiTooltip;
-import net.minecraft.client.gui.guidebook.*;
+import net.minecraft.client.gui.guidebook.GuiGuidebook;
+import net.minecraft.client.gui.guidebook.GuidebookPage;
+import net.minecraft.client.gui.guidebook.GuidebookSection;
+import net.minecraft.client.gui.guidebook.GuidebookSections;
+import net.minecraft.client.gui.guidebook.PageManager;
+import net.minecraft.client.gui.guidebook.RecipePage;
 import net.minecraft.client.gui.guidebook.search.SearchPage;
-import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.RenderEngine;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.achievement.AchievementList;
-import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.SearchQuery;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.SlotGuidebook;
 import org.lwjgl.input.Keyboard;
@@ -169,11 +172,11 @@ public class TrommelPage
     @Override
     protected void renderBackground(RenderEngine re, int x, int y) {
         super.renderBackground(re, x, y);
-        re.bindTexture(re.getTexture("/gui/crafting.png"));
+        re.bindTexture(re.getTexture("/assets/minecraft/textures/gui/guidebook/guidebook.png"));
         for (int i = 1; i <= recipes.size(); i++) {
             RecipeEntryTrommel recipe = recipes.get(i-1);
             List<SlotGuidebook> list = map.get(recipe);
-            drawTexturedModalRect(x + list.get(list.size()-1).xDisplayPosition + 25, y +  list.get(list.size()-1).yDisplayPosition, 90, 35, 22, 15);
+            drawTexturedModalRect(x + list.get(list.size()-1).xDisplayPosition + 25, y +  list.get(list.size()-1).yDisplayPosition, 234, 0, 22, 15);
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/hud/ArmorBarComponent.java b/src/main/java/net/minecraft/client/gui/hud/ArmorBarComponent.java
index 142c10698..fbf8a40bb 100644
--- a/src/main/java/net/minecraft/client/gui/hud/ArmorBarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/ArmorBarComponent.java
@@ -23,7 +23,7 @@ public class ArmorBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/icons.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int armorValue = mc.thePlayer.getPlayerProtectionAmount();
@@ -57,7 +57,7 @@ public class ArmorBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/icons.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int armorValue = 11;
diff --git a/src/main/java/net/minecraft/client/gui/hud/CrosshairComponent.java b/src/main/java/net/minecraft/client/gui/hud/CrosshairComponent.java
index a01201c99..f228bde20 100644
--- a/src/main/java/net/minecraft/client/gui/hud/CrosshairComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/CrosshairComponent.java
@@ -23,7 +23,7 @@ public class CrosshairComponent
 
         // Setup crosshair texture
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/icons.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
 
         // Render crosshair
         GL11.glEnable(GL11.GL_BLEND);
@@ -39,7 +39,7 @@ public class CrosshairComponent
 
         // Setup crosshair texture
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/icons.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
 
         // Render crosshair
         gui.drawTexturedModalRect(x, y, 0, 0, 15, 15);
diff --git a/src/main/java/net/minecraft/client/gui/hud/FireBarComponent.java b/src/main/java/net/minecraft/client/gui/hud/FireBarComponent.java
index 0e4c36042..1bfc5d1d9 100644
--- a/src/main/java/net/minecraft/client/gui/hud/FireBarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/FireBarComponent.java
@@ -23,7 +23,7 @@ public class FireBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/icons.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         float fire = (float) mc.thePlayer.remainingFireTicks / (float) mc.thePlayer.maxFireTicks;
@@ -41,7 +41,7 @@ public class FireBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/icons.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int fireBar = 11;
diff --git a/src/main/java/net/minecraft/client/gui/hud/HealthBarComponent.java b/src/main/java/net/minecraft/client/gui/hud/HealthBarComponent.java
index 89016fb6a..ea72f10af 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HealthBarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/HealthBarComponent.java
@@ -30,7 +30,7 @@ public class HealthBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/icons.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         boolean heartsFlash = (mc.thePlayer.heartsFlashTime / 3) % 2 == 1;
@@ -118,7 +118,7 @@ public class HealthBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/icons.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int health = 11;
diff --git a/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java b/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
index 7dae5f901..1fff3afdb 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
@@ -57,7 +57,7 @@ public class HotbarComponent
 
         // Setup hotbar texture
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/gui.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/gui.png"));
 
         // Render hotbar
         gui.drawTexturedModalRect(x + 5, y, 0, 0, 182, 22);
@@ -119,7 +119,7 @@ public class HotbarComponent
 
         // Setup hotbar texture
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/gui.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/gui.png"));
 
         // Render selector
         gui.drawTexturedModalRect((x + 4) + (inv.currentItem % 9) * 20, y - 1, 0, 22, 24, 24);
@@ -132,7 +132,7 @@ public class HotbarComponent
 
         // Setup hotbar texture
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/gui.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/gui.png"));
 
         // Render hotbar
         gui.drawTexturedModalRect(x + 5, y, 0, 0, 182, 22);
diff --git a/src/main/java/net/minecraft/client/gui/hud/OxygenBarComponent.java b/src/main/java/net/minecraft/client/gui/hud/OxygenBarComponent.java
index f5fcd1a91..f1a5542d3 100644
--- a/src/main/java/net/minecraft/client/gui/hud/OxygenBarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/OxygenBarComponent.java
@@ -24,7 +24,7 @@ public class OxygenBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/icons.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int numBubbles = (int) Math.ceil(((double) (mc.thePlayer.airSupply - 2) * 10D) / 300D);
@@ -49,7 +49,7 @@ public class OxygenBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/icons.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int numBubbles = 5;
diff --git a/src/main/java/net/minecraft/client/gui/hud/RotationLockComponent.java b/src/main/java/net/minecraft/client/gui/hud/RotationLockComponent.java
index 51458fc85..9856d4d73 100644
--- a/src/main/java/net/minecraft/client/gui/hud/RotationLockComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/RotationLockComponent.java
@@ -22,7 +22,7 @@ public class RotationLockComponent
     public void render(Minecraft mc, GuiIngame gui, int xSizeScreen, int ySizeScreen, float partialTick) {
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/icons.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
@@ -90,7 +90,7 @@ public class RotationLockComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/icons.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int u = mc.gameSettings.rotationOverlayMode.value % 2 == 1 ? 16 : 0;
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java
index d699db98a..022063230 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java
@@ -16,12 +16,10 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.chunk.DisplayChunk;
 
-import java.util.ArrayList;
 import java.util.HashMap;
 import java.util.List;
 
 public class BlockCategory extends ModelViewerCategory {
-    public List<GuiButton> buttonBuffer = new ArrayList<>();
     public HashMap<Block, BlockEntry> entryHashMap = new HashMap<>();
     public GuiTextCycle<Integer> blockIdTextField;
     public GuiTextCycle<Integer> blockMetaTextField;
@@ -62,7 +60,6 @@ public class BlockCategory extends ModelViewerCategory {
     @Override
     public void addContextButtons(List<GuiButton> buttonList) {
         GuiButton lastButton = buttonList.get(buttonList.size()-1);
-        buttonBuffer.clear();
 
         modelViewer.buttonNextEntry.enabled = false;
         modelViewer.buttonPrevEntry.enabled = false;
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java
index a015ecdc8..49ea7430d 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.gui.modelviewer.categories;
 
+import net.minecraft.client.entity.fx.ParticleDispatcher;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.gui.modelviewer.categories.entries.particle.BlockFXEntry;
@@ -14,43 +15,33 @@ import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
 import net.minecraft.core.lang.I18n;
 
 import java.util.ArrayList;
+import java.util.Comparator;
+import java.util.HashMap;
 import java.util.List;
+import java.util.Map;
 
 public class ParticleCategory extends ModelViewerCategory{
-    public List<ParticleEntry> entries = new ArrayList<>();
+    public Map<String, ParticleEntry> entryMap = new HashMap<>();
+    public List<ParticleEntry> entriesList;
     public double spawnRadius = 0;
     public ParticleEntry currentEntry;
 
     public ParticleCategory(GuiModelViewer modelViewer) {
         super(modelViewer);
         initEntries();
+        entriesList = new ArrayList<>(entryMap.values());
+        entriesList.sort(Comparator.comparing(o -> o.getParticleName(I18n.getInstance())));
     }
     private void initEntries(){
-        entries.add(new BubbleFXEntry());
-        entries.add(new GenericFXEntry("smoke"));
-        entries.add(new NoteFXEntry());
-        entries.add(new GenericFXEntry("portal"));
-        entries.add(new GenericFXEntry("explode"));
-        entries.add(new GenericFXEntry("flame"));
-        entries.add(new GenericFXEntry("blueflame"));
-        entries.add(new GenericFXEntry("soulflame"));
-        entries.add(new GenericFXEntry("lava"));
-        entries.add(new GenericFXEntry("footstep"));
-        entries.add(new GenericFXEntry("splash"));
-        entries.add(new GenericFXEntry("largesmoke"));
-        entries.add(new RedDustFXEntry());
-        entries.add(new ItemFXEntry());
-        entries.add(new BlockFXEntry());
-        entries.add(new GenericFXEntry("snowshovel"));
-        entries.add(new GenericFXEntry("heart"));
-        entries.add(new GenericFXEntry("slimechunk"));
-        entries.add(new GenericFXEntry("fireflyGreen"));
-        entries.add(new GenericFXEntry("fireflyBlue"));
-        entries.add(new GenericFXEntry("fireflyOrange"));
-        entries.add(new GenericFXEntry("fireflyRed"));
-        entries.add(new GenericFXEntry("arrowtrail"));
-        entries.add(new LeafFXEntry());
-        entries.add(new GenericFXEntry("boatbreak"));
+        for (String s : ParticleDispatcher.getInstance().getParticleIds()){
+            entryMap.put(s, new GenericFXEntry(s));
+        }
+        entryMap.put("bubble", new BubbleFXEntry());
+        entryMap.put("note", new NoteFXEntry());
+        entryMap.put("reddust", new RedDustFXEntry());
+        entryMap.put("item", new ItemFXEntry());
+        entryMap.put("block", new BlockFXEntry());
+        entryMap.put("fallingleaf", new LeafFXEntry());
     }
     private void setCurrentEntry(ParticleEntry entry){
         if (currentEntry != null){
@@ -97,7 +88,7 @@ public class ParticleCategory extends ModelViewerCategory{
 
     @Override
     public void cycleCategoryEntry(int offset) {
-        setCurrentEntry(entries.get((entries.indexOf(currentEntry) + entries.size() + offset) % entries.size()));
+        setCurrentEntry(entriesList.get((entriesList.indexOf(currentEntry) + entriesList.size() + offset) % entriesList.size()));
         mc.effectRenderer.clearEffects(mc.theWorld);
         modelViewer.init();
     }
@@ -105,7 +96,7 @@ public class ParticleCategory extends ModelViewerCategory{
     @Override
     public void onOpen() {
         spawnRadius = 0;
-        setCurrentEntry(entries.get(0));
+        setCurrentEntry(entriesList.get(0));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java
index 3cc3a7c9e..0c305b3c3 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java
@@ -59,12 +59,12 @@ public class EntityWolfEntry extends EntityEntry<EntityWolf>{
         GuiListSelectorButton<ArmorMaterial> armor = new GuiListSelectorButton<ArmorMaterial>(-1, - 120, angry.yPosition + 21, 120, 20, I18n.getInstance().translateKey("model.category.entity.wolf.button.armor"), armorMaterials,null) {
             @Override
             public String getNameFromElement(ArmorMaterial element) {
-                return element == null ? "none" : element.name;
+                return element == null ? "none" : element.identifier.toString();
             }
         };
         armor.setActionListener(() -> {
             ArmorMaterial material = armor.getCurrentElement();
-            entityWolf.getEntityData().set(19, material == null ? "" : material.name);
+            entityWolf.getEntityData().set(19, material == null ? "" : material.identifier.toString());
         });
 
         entityWolf.setWolfHeldItem(null);
diff --git a/src/main/java/net/minecraft/client/gui/options/GuiOptions.java b/src/main/java/net/minecraft/client/gui/options/GuiOptions.java
index 18a3e4f5c..a3795479e 100644
--- a/src/main/java/net/minecraft/client/gui/options/GuiOptions.java
+++ b/src/main/java/net/minecraft/client/gui/options/GuiOptions.java
@@ -470,7 +470,7 @@ public class GuiOptions
         if (mc.theWorld == null)
         {
             TessellatorStandard tessellator = TessellatorStandard.instance;
-            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/background.png"));
+            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
@@ -501,7 +501,7 @@ public class GuiOptions
         if (mc.theWorld == null)
         {
             TessellatorStandard tessellator = TessellatorStandard.instance;
-            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/background.png"));
+            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
diff --git a/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java b/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
index 76e76b2b1..0855d3aef 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
@@ -26,7 +26,7 @@ public abstract class ButtonComponent
     public ButtonComponent(String translationKey)
     {
         this.translationKey = translationKey;
-        this.resetButton = new GuiTexturedButton(0, "/gui/gui.png", 0, 0, 40, 86, 20, 20);
+        this.resetButton = new GuiTexturedButton(0, "/assets/minecraft/textures/gui/gui.png", 0, 0, 40, 86, 20, 20);
     }
 
     public abstract void resetValue();
diff --git a/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java b/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
index 4019bc1a4..d28f1abc4 100644
--- a/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
+++ b/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
@@ -427,7 +427,7 @@ public class GuiPaged
         if (mc.theWorld == null)
         {
             TessellatorStandard tessellator = TessellatorStandard.instance;
-            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/background.png"));
+            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
@@ -458,7 +458,7 @@ public class GuiPaged
         if (mc.theWorld == null)
         {
             TessellatorStandard tessellator = TessellatorStandard.instance;
-            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/background.png"));
+            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
diff --git a/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java b/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java
index 985033b8c..18c063e48 100644
--- a/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java
+++ b/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java
@@ -202,7 +202,7 @@ public final class GuiPopup
         GL11.glEnable(GL11.GL_TEXTURE_2D);
         float f = 32F;
         tessellator.startDrawingQuads();
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/background.png"));
+        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
         tessellator.setColorOpaque_I(0x404040);
         tessellator.addVertexWithUV(popupX, popupY + popupHeight, 0.0D, 0.0D, (float)popupHeight / f);
         tessellator.addVertexWithUV(popupX + popupWidth, popupY + popupHeight, 0.0D, (float)popupWidth / f, (float)popupHeight / f);
diff --git a/src/main/java/net/minecraft/client/option/enums/TooltipStyle.java b/src/main/java/net/minecraft/client/option/enums/TooltipStyle.java
index 37aeab055..432451967 100644
--- a/src/main/java/net/minecraft/client/option/enums/TooltipStyle.java
+++ b/src/main/java/net/minecraft/client/option/enums/TooltipStyle.java
@@ -28,7 +28,7 @@ public enum TooltipStyle
 
     public String getFilePath()
     {
-        return "/gui/tooltip/" + name + ".png";
+        return "/assets/minecraft/textures/gui/tooltip/" + name + ".png";
     }
 
     public String getTranslationKey()
diff --git a/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java b/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
index be6e8b94d..d0513efb6 100644
--- a/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
+++ b/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
@@ -25,7 +25,7 @@ public class LoadingScreenRenderer
     private String title = "";
     private long startTime = System.currentTimeMillis();
     private boolean canStop = false;
-    private String backgroundPath = "/gui/background.png";
+    private String backgroundPath = "/assets/minecraft/textures/gui/background.png";
     private int startStackDepth = 0;
     private String tip = "";
 
@@ -110,15 +110,15 @@ public class LoadingScreenRenderer
     {
         if (dimension == Dimension.nether)
         {
-            backgroundPath = "/gui/background-loading-nether.png";
+            backgroundPath = "/assets/minecraft/textures/gui/background-loading-nether.png";
         }
         else if (dimension == Dimension.paradise)
         {
-            backgroundPath = "/gui/background-loading-paradise.png";
+            backgroundPath = "/assets/minecraft/textures/gui/background-loading-paradise.png";
         }
         else
         {
-            backgroundPath = "/gui/background.png";
+            backgroundPath = "/assets/minecraft/textures/gui/background.png";
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/RenderEngine.java b/src/main/java/net/minecraft/client/render/RenderEngine.java
index 9c469d4ad..0aaf51545 100644
--- a/src/main/java/net/minecraft/client/render/RenderEngine.java
+++ b/src/main/java/net/minecraft/client/render/RenderEngine.java
@@ -36,8 +36,6 @@ import net.minecraft.client.util.helper.Colors;
 import net.minecraft.client.util.helper.TexturePackJsonHelper;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.util.helper.Buffer;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
 
 import java.awt.image.BufferedImage;
 import java.io.IOException;
@@ -211,6 +209,7 @@ public class RenderEngine {
                         String id = TexturePackJsonHelper.getString(animationObject, "id");
 						String name = TexturePackJsonHelper.getString(animationObject, "name");
 
+						if (!TextureRegistry.hasTexture(id)) throw new TexturePackException("Texture id '" + id + "' appears to be invalid!");
 						IconCoordinate texture = TextureRegistry.getTexture(id);
 
 						String texturePath = "/anim/" + name + ".png";
